Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/builder.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -60,4 +60,5 @@
 #include "bondgraph.hpp"
 #include "boundary.hpp"
+#include "CommandLineParser.hpp"
 #include "config.hpp"
 #include "element.hpp"
@@ -76,6 +77,7 @@
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/ActionHistory.hpp"
+#include "Actions/MapOfActions.hpp"
 #include "Actions/MethodAction.hpp"
-#include "Actions/small_actions.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
 #include "World.hpp"
 #include "version.h"
@@ -1479,4 +1481,6 @@
 
 /** Parses the command line options.
+ * Note that this function is from now on transitional. All commands that are not passed
+ * here are handled by CommandLineParser and the actions of CommandLineUIFactory.
  * \param argc argument count
  * \param **argv arguments array
@@ -1486,8 +1490,9 @@
  * \param *ConfigFileName pointer to config file name in **argv
  * \param *PathToDatabases pointer to db's path in **argv
+ * \param &ArgcList list of arguments that we do not parse here
  * \return exit code (0 - successful, all else - something's wrong)
  */
-static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode,\
-                                   config& configuration, char *&ConfigFileName)
+static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode,
+                                   config& configuration, char *&ConfigFileName, list<int> &ArgcList)
 {
   Vector x,y,z,n;  // coordinates for absolute point in cell volume
@@ -1507,5 +1512,4 @@
   molecule *mol = NULL;
   string BondGraphFileName("\n");
-  int verbosity = 0;
   strncpy(configuration.databasepath, LocalPath, MAXSTRINGSIZE-1);
 
@@ -1521,58 +1525,15 @@
           case 'H':
           case '?':
-            DoLog(0) && (Log() << Verbose(0) << "MoleCuilder suite" << endl << "==================" << endl << endl);
-            DoLog(0) && (Log() << Verbose(0) << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl);
-            DoLog(0) && (Log() << Verbose(0) << "or simply " << argv[0] << " without arguments for interactive session." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-A <source>\tCreate adjacency list from bonds parsed from 'dbond'-style file." <<endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-b xx xy xz yy yz zz\tCenter atoms in domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-B xx xy xz yy yz zz\tBound atoms by domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-C <type> [params] <output> <bin output> <BinWidth> <BinStart> <BinEnd>\tPair Correlation analysis." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-f <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-F <xyz of filler> <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-FF <MaxDistance> <xyz of filler> <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-g <file>\tParses a bond length table from the given file." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-h/-H/-?\tGive this help screen." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-I\t Dissect current system of molecules into a set of disconnected (subgraphs of) molecules." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-j\t<path> Store all bonds to file." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-J\t<path> Store adjacency per atom to file." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-L <step0> <step1> <prefix>\tStore a linear interpolation between two configurations <step0> and <step1> into single config files with prefix <prefix> and as Trajectories into the current config file." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-M <basis>\tSetting basis to store to MPQC config files." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-N <radius> <file>\tGet non-convex-envelope." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-o <out>\tGet volume of the convex envelope (and store to tecplot file)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-O\tCenter atoms in origin." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-P <file>\tParse given forces file and append as an MD step to config file via Verlet." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-r <id>\t\tRemove an atom with given id." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-R <id> <radius>\t\tRemove all atoms out of sphere around a given one." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-S <file> Store temperatures from the config file in <file>." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-T x1 x2 x3\tTranslate periodically all atoms by this vector (x1,x2,x3)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-v\t\tsets verbosity (more is more)." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-V\t\tGives version information." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "\t-X\t\tset default name of a molecule." << endl);
-            DoLog(0) && (Log() << Verbose(0) << "Note: config files must not begin with '-' !" << endl);
-            return (1);
+            ArgcList.push_back(argptr-1);
+            return(1);
             break;
           case 'v':
-            while (argv[argptr-1][verbosity+1] == 'v') {
-              verbosity++;
-            }
-            setVerbosity(verbosity);
-            DoLog(0) && (Log() << Verbose(0) << "Setting verbosity to " << verbosity << "." << endl);
+            ArgcList.push_back(argptr-1);
+            return(1);
             break;
           case 'V':
-            DoLog(0) && (Log() << Verbose(0) << argv[0] << " " << VERSIONSTRING << endl);
-            DoLog(0) && (Log() << Verbose(0) << "Build your own molecule position set." << endl);
-            return (1);
+            ArgcList.push_back(argptr-1);
+            ArgcList.push_back(argptr);
+            argptr++;
             break;
           case 'B':
@@ -2511,35 +2472,8 @@
 };
 
-/***************************************** Functions used to build all menus **********************/
-
-void populateEditMoleculesMenu(Menu* editMoleculesMenu,MoleculeListClass *molecules, config *configuration, periodentafel *periode){
-  // build the EditMoleculesMenu
-  Action *createMoleculeAction = new MethodAction("createMoleculeAction",boost::bind(&MoleculeListClass::createNewMolecule,molecules,periode));
-  new ActionMenuItem('c',"create new molecule",editMoleculesMenu,createMoleculeAction);
-
-  Action *loadMoleculeAction = new MethodAction("loadMoleculeAction",boost::bind(&MoleculeListClass::loadFromXYZ,molecules,periode));
-  new ActionMenuItem('l',"load molecule from xyz file",editMoleculesMenu,loadMoleculeAction);
-
-  Action *changeFilenameAction = new ChangeMoleculeNameAction(molecules);
-  new ActionMenuItem('n',"change molecule's name",editMoleculesMenu,changeFilenameAction);
-
-  Action *giveFilenameAction = new MethodAction("giveFilenameAction",boost::bind(&MoleculeListClass::setMoleculeFilename,molecules));
-  new ActionMenuItem('N',"give molecules filename",editMoleculesMenu,giveFilenameAction);
-
-  Action *parseAtomsAction = new MethodAction("parseAtomsAction",boost::bind(&MoleculeListClass::parseXYZIntoMolecule,molecules));
-  new ActionMenuItem('p',"parse atoms in xyz file into molecule",editMoleculesMenu,parseAtomsAction);
-
-  Action *eraseMoleculeAction = new MethodAction("eraseMoleculeAction",boost::bind(&MoleculeListClass::eraseMolecule,molecules));
-  new ActionMenuItem('r',"remove a molecule",editMoleculesMenu,eraseMoleculeAction);
-
-}
-
-
 /********************************************** Main routine **************************************/
 
-void cleanUp(config *configuration){
-  UIFactory::purgeInstance();
+void cleanUp(){
   World::purgeInstance();
-  delete(configuration);
   Log() << Verbose(0) <<  "Maximum of allocated memory: "
     << MemoryUsageObserver::getInstance()->getMaximumUsedMemory() << endl;
@@ -2549,4 +2483,7 @@
   logger::purgeInstance();
   errorLogger::purgeInstance();
+  UIFactory::purgeInstance();
+  MapOfActions::purgeInstance();
+  CommandLineParser::purgeInstance();
   ActionRegistry::purgeInstance();
   ActionHistory::purgeInstance();
@@ -2555,12 +2492,12 @@
 int main(int argc, char **argv)
 {
-    molecule *mol = NULL;
-    config *configuration = new config;
+    config *configuration = World::getInstance().getConfig();
     Vector x, y, z, n;
     ifstream test;
     ofstream output;
     string line;
-    char *ConfigFileName = NULL;
-    int j;
+    char **Arguments = NULL;
+    int ArgcSize = 0;
+    bool ArgumentsCopied = false;
 
     cout << ESPACKVersion << endl;
@@ -2569,39 +2506,38 @@
     // need to init the history before any action is created
     ActionHistory::init();
-    /* structure of ParseCommandLineOptions will be refactored later */
-    j = ParseCommandLineOptions(argc, argv,  World::getInstance().getMolecules(), World::getInstance().getPeriode(), *configuration, ConfigFileName);
-    switch (j){
-        case 255:
-        case 2:
-        case 1:
-            cleanUp(configuration);
-            return (j == 1 ? 0 : j);
-        default:
-            break;
+
+    // Parse command line options and if present create respective UI
+    {
+      list<int> ArgcList;
+      ArgcList.push_back(0); // push back program!
+      ArgcList.push_back(1); // push back config file name
+      char ConfigFileName[MAXSTRINGSIZE];
+      // handle arguments by ParseCommandLineOptions()
+      ParseCommandLineOptions(argc,argv,World::getInstance().getMolecules(),World::getInstance().getPeriode(),*World::getInstance().getConfig(), (char *&)ConfigFileName, ArgcList);
+      // copy all remaining arguments to a new argv
+      Arguments = Malloc<char *>(ArgcList.size(), "main - **Arguments");
+      cout << "The following arguments are handled by CommandLineParser: ";
+      for (list<int>::iterator ArgcRunner = ArgcList.begin(); ArgcRunner != ArgcList.end(); ++ArgcRunner) {
+        Arguments[ArgcSize] = Malloc<char>(strlen(argv[*ArgcRunner])+2, "main - *Arguments[]");
+        strcpy(Arguments[ArgcSize], argv[*ArgcRunner]);
+        cout << " " << argv[*ArgcRunner];
+        ArgcSize++;
+      }
+      cout << endl;
+      ArgumentsCopied = true;
+      // handle remaining arguments by CommandLineParser
+      MapOfActions::getInstance().AddOptionsToParser();
+      CommandLineParser::getInstance().Run(ArgcSize,Arguments);
+      if (!CommandLineParser::getInstance().isEmpty()) {
+        DoLog(0) && (Log() << Verbose(0) << "Setting UI to CommandLine." << endl);
+        UIFactory::makeUserInterface(UIFactory::CommandLine);
+      } else {
+        DoLog(0) && (Log() << Verbose(0) << "Setting UI to Text." << endl);
+        UIFactory::makeUserInterface(UIFactory::Text);
+      }
     }
-    if(World::getInstance().numMolecules() == 0){
-        mol = World::getInstance().createMolecule();
-        World::getInstance().getMolecules()->insert(mol);
-        cout << "Molecule created" << endl;
-        if(World::getInstance().getDomain()[0] == 0.){
-            Log() << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl;
-            for(int i = 0;i < 6;i++){
-                Log() << Verbose(1) << "Cell size" << i << ": ";
-                cin >> World::getInstance().getDomain()[i];
-            }
-        }
-        mol->ActiveFlag = true;
-    }
 
     {
-      cout << ESPACKVersion << endl;
-
-      setVerbosity(0);
-
-      menuPopulaters populaters;
-      populaters.MakeEditMoleculesMenu = populateEditMoleculesMenu;
-
-      UIFactory::makeUserInterface(UIFactory::Text);
-      MainWindow *mainWindow = UIFactory::getInstance().makeMainWindow(populaters,World::getInstance().getMolecules(), configuration, World::getInstance().getPeriode(), ConfigFileName);
+      MainWindow *mainWindow = UIFactory::getInstance().makeMainWindow();
       mainWindow->display();
       delete mainWindow;
@@ -2614,6 +2550,12 @@
         Log() << Verbose(0) << "Saving of elements.db failed." << endl;
 
-  cleanUp(configuration);
-
+  // free the new argv
+  if (ArgumentsCopied) {
+    for (int i=0; i<ArgcSize;i++)
+      Free(&Arguments[i]);
+    Free(&Arguments);
+  }
+
+  cleanUp();
   Memory::getState();
   return (0);
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/molecule.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -35,4 +35,6 @@
 #include "Patterns/Observer.hpp"
 #include "Patterns/Cacheable.hpp"
+
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
 
 /****************************************** forward declarations *****************************/
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/unittests/Makefile.am	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -1,2 +1,5 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
 INCLUDES = -I$(top_srcdir)/src
 
@@ -32,4 +35,5 @@
   PlaneUnittest \
   ObserverTest \
+  ParserUnitTest \
   SingletonTest \
   StackClassUnitTest \
@@ -73,4 +77,5 @@
   PlaneUnittest.cpp \
   ObserverTest.cpp \
+  ParserUnitTest.cpp \
   SingletonTest.cpp \
   stackclassunittest.cpp \
@@ -114,4 +119,7 @@
   
 
+ActionSequenceTest_SOURCES = UnitTestMain.cpp ../../../TestRunnerClient.hpp ActionSequenceTest.cpp ActionSequenceTest.hpp
+ActionSequenceTest_LDADD = ${ALLLIBS}
+
 ActOnAllUnitTest_SOURCES = UnitTestMain.cpp ../test/ActOnAllTest.hpp ActOnAllUnitTest.cpp ActOnAllUnitTest.hpp
 ActOnAllUnitTest_LDADD = ${ALLLIBS}
@@ -132,7 +140,13 @@
 atomsCalculationTest_LDADD = ${ALLLIBS}
 
+AtomDescriptorTest_SOURCES = UnitTestMain.cpp AtomDescriptorTest.cpp AtomDescriptorTest.hpp
+AtomDescriptorTest_LDADD = ${ALLLIBS}
+
 BondGraphUnitTest_SOURCES = UnitTestMain.cpp bondgraphunittest.cpp bondgraphunittest.hpp
 BondGraphUnitTest_LDADD = ${ALLLIBS}
 
+CacheableTest_SOURCES = UnitTestMain.cpp CacheableTest.cpp CacheableTest.hpp
+CacheableTest_LDADD = ${ALLLIBS}
+
 CountBondsUnitTest_SOURCES = UnitTestMain.cpp CountBondsUnitTest.cpp CountBondsUnitTest.hpp
 CountBondsUnitTest_LDADD = ${ALLLIBS}
@@ -162,4 +176,7 @@
 LogUnitTest_LDADD = ${ALLLIBS}
 
+manipulateAtomsTest_SOURCES = UnitTestMain.cpp manipulateAtomsTest.cpp manipulateAtomsTest.hpp
+manipulateAtomsTest_LDADD = ${ALLLIBS}
+
 MemoryAllocatorUnitTest_SOURCES = UnitTestMain.cpp memoryallocatorunittest.cpp memoryallocatorunittest.hpp 
 MemoryAllocatorUnitTest_LDADD = ${ALLLIBS}
@@ -171,4 +188,10 @@
 MoleculeDescriptorTest_LDADD = ${ALLLIBS}
 
+ObserverTest_SOURCES = UnitTestMain.cpp ObserverTest.cpp ObserverTest.hpp
+ObserverTest_LDADD = ${ALLLIBS}
+
+ParserUnitTest_SOURCES = UnitTestMain.cpp ParserUnitTest.cpp ParserUnitTest.hpp
+ParserUnitTest_LDADD = ${ALLLIBS}
+
 PlaneUnittest_SOURCES = UnitTestMain.cpp PlaneUnittest.cpp PlaneUnittest.hpp
 PlaneUnittest_LDADD = ${ALLLIBS}
@@ -189,25 +212,9 @@
 Tesselation_InOutsideUnitTest_LDADD = ${ALLLIBS}
 
+TestRunner_SOURCES = TestRunnerMain.cpp $(TESTSOURCES) $(TESTHEADERS)
+TestRunner_LDADD = ${ALLLIBS}
+
 VectorUnitTest_SOURCES = UnitTestMain.cpp vectorunittest.cpp vectorunittest.hpp 
 VectorUnitTest_LDADD = ${ALLLIBS}
 
-ActionSequenceTest_SOURCES = UnitTestMain.cpp ../../../TestRunnerClient.hpp ActionSequenceTest.cpp ActionSequenceTest.hpp
-ActionSequenceTest_LDADD = ${ALLLIBS}
-
-ObserverTest_SOURCES = UnitTestMain.cpp ObserverTest.cpp ObserverTest.hpp
-ObserverTest_LDADD = ${ALLLIBS}
-
-CacheableTest_SOURCES = UnitTestMain.cpp CacheableTest.cpp CacheableTest.hpp
-CacheableTest_LDADD = ${ALLLIBS}
-
-AtomDescriptorTest_SOURCES = UnitTestMain.cpp AtomDescriptorTest.cpp AtomDescriptorTest.hpp
-AtomDescriptorTest_LDADD = ${ALLLIBS}
-
-manipulateAtomsTest_SOURCES = UnitTestMain.cpp manipulateAtomsTest.cpp manipulateAtomsTest.hpp
-manipulateAtomsTest_LDADD = ${ALLLIBS}
-
-TestRunner_SOURCES = TestRunnerMain.cpp $(TESTSOURCES) $(TESTHEADERS)
-TestRunner_LDADD = ${ALLLIBS}
-
 #AUTOMAKE_OPTIONS = parallel-tests
-
Index: src/unittests/MapofActionsTest.cpp
===================================================================
--- src/unittests/MapofActionsTest.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/unittests/MapofActionsTest.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,65 @@
+/*
+ * analysisbondsunittest.cpp
+ *
+ *  Created on: Nov 7, 2009
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+#include <stdio.h>
+#include <cstring>
+
+#include "MapOfActionsTest.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MapOfActionsTest );
+
+
+void MapOfActionsTest::setUp()
+{
+  MapOfActions *ActionData = MapOfActions::getInstance();
+};
+
+
+void MapOfActionsTest::tearDown()
+{
+  // note that all the atoms are cleaned by TestMolecule
+  MapOfActions::purgeInstance();
+};
+
+/** UnitTest: check whether each short form action also has a description (the other way round is not always true)
+ */
+void MapOfActionsTest::ShortFormConsistencyTest()
+{
+  for (map<string, string>::iterator ShortFormRunner = ActionData->ShortFormMap.begin(); ShortFormRunner = ActionData->ShortFormMap.begin(); ++ShortFormRunner) {
+    CPPUNIT_ASSERT( ActionData->DescriptionMap.find(ShortFormRunner->first) != ActionData->DescriptionMap.end() && "There is a short form without description.");
+  }
+};
+
+/** UnitTest: check whether each action appears in a list one of the option lists
+ */
+void MapOfActionsTest::OptionsListsConsistencyTest()
+{
+  bool haveFound = false;
+  for (map<string, string>::iterator ActionRunner = ActionData->DescriptionMap.begin(); ShortFormRunner = ActionData->DescriptionMap.begin(); ++ShortFormRunner) {
+    haveFound = haveFound || (ActionData->generic.find(ActionRunner->first) != ActionData->generic.end());
+    haveFound = haveFound || (ActionData->config.find(ActionRunner->first) != ActionData->config.end());
+    haveFound = haveFound || (ActionData->hidden.find(ActionRunner->first) != ActionData->hidden.end());
+    haveFound = haveFound || (ActionData->visible.find(ActionRunner->first) != ActionData->visible.end());
+    CPPUNIT_ASSERT_EQUAL( true , haveFound);
+  }
+};
+
Index: src/unittests/MapofActionsTest.hpp
===================================================================
--- src/unittests/MapofActionsTest.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/unittests/MapofActionsTest.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,37 @@
+/*
+ * analysisbondsunittest.hpp
+ *
+ *  Created on: Nov 7, 2009
+ *      Author: heber
+ */
+
+#ifndef MAPOFACTIONS_HPP_
+#define MAPOFACTIONS_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class BondGraph;
+class element;
+class molecule;
+class periodentafel;
+
+/********************************************** Test classes **************************************/
+
+class MapOfActionsTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( MapOfActionsTest) ;
+    CPPUNIT_TEST ( ShortFormConsistencyTest );
+    CPPUNIT_TEST ( OptionsListsConsistencyTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void ShortFormConsistencyTest();
+      void OptionsListsConsistencyTest();
+
+private:
+
+      MapOfActions *ActionData;
+
+#endif /* MAPOFACTIONS_HPP_ */
Index: src/unittests/ParserUnitTest.cpp
===================================================================
--- src/unittests/ParserUnitTest.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/unittests/ParserUnitTest.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,186 @@
+/*
+ * ParserUnitTest.cpp
+ *
+ *  Created on: Mar 3, 2010
+ *      Author: metzler
+ */
+
+#include "ParserUnitTest.hpp"
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "Parser/XyzParser.hpp"
+#include "Parser/TremoloParser.hpp"
+#include "World.hpp"
+#include "atom.hpp"
+#include "element.hpp"
+#include "periodentafel.hpp"
+#include "Descriptors/AtomTypeDescriptor.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+using namespace std;
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( ParserUnitTest );
+
+
+void ParserUnitTest::setUp() {
+  element* oxygen = new element();
+  oxygen->symbol[0] = 'O';
+  oxygen->Z = 8;
+  World::getInstance().getPeriode()->AddElement(oxygen);
+
+  element* hydrogen = new element();
+  hydrogen->symbol[0] = 'H';
+  hydrogen->Z = 1;
+  World::getInstance().getPeriode()->AddElement(hydrogen);
+}
+
+void ParserUnitTest::tearDown() {
+  World::purgeInstance();
+}
+
+/************************************ tests ***********************************/
+
+void ParserUnitTest::rewriteAnXyzTest() {
+  cout << "Testing the XYZ parser." << endl;
+  XyzParser* testParser = new XyzParser();
+  string waterXyz = "3\nH2O: water molecule\nO\t0.000000\t0.000000\t0.000000\nH\t0.758602\t0.000000\t0.504284\nH\t0.758602\t0.000000\t-0.504284\n";
+  stringstream input;
+  input << waterXyz;
+  testParser->load(&input);
+
+  CPPUNIT_ASSERT_EQUAL(3, World::getInstance().numAtoms());
+
+  string newWaterXyz = "";
+  stringstream output;
+  testParser->save(&output);
+  newWaterXyz = output.str();
+
+  CPPUNIT_ASSERT(waterXyz == newWaterXyz);
+}
+
+void ParserUnitTest::readTremoloPreliminaryCommentsTest() {
+  cout << "Testing the tremolo parser." << endl;
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input, output;
+  string waterTremolo;
+
+  // Atomdata beginning with "# ATOMDATA"
+  waterTremolo = "# ATOMDATA\tId\tname\tType\tx=3\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  testParser->save(&output);
+  CPPUNIT_ASSERT(waterTremolo == output.str());
+  input.clear();
+  output.clear();
+
+  // Atomdata beginning with "#ATOMDATA"
+  waterTremolo = "#\n#ATOMDATA Id name Type x=3\n1 hydrogen H 3.0 4.5 0.1\n\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  testParser->save(&output);
+  CPPUNIT_ASSERT(output.str().find("hydrogen") != string::npos);
+  input.clear();
+  output.clear();
+
+  // Invalid key in Atomdata line
+  waterTremolo = "#\n#ATOMDATA Id name foo Type x=3\n\n\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  //TODO: proove invalidity
+  input.clear();
+}
+
+void ParserUnitTest::readTremoloCoordinatesTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input;
+  string waterTremolo;
+
+  // One simple data line
+  waterTremolo = "#\n#ATOMDATA Id name Type x=3\n1 hydrogen H 3.0 4.5 0.1\n\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->x[0] == 3.0);
+  input.clear();
+}
+
+void ParserUnitTest::readTremoloVelocityTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input;
+  string waterTremolo;
+
+  // One simple data line
+  waterTremolo = "#\n#ATOMDATA Id name Type u=3\n1 hydrogen H 3.0 4.5 0.1\n\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->v[0] == 3.0);
+  input.clear();
+}
+
+void ParserUnitTest::readTremoloNeighborInformationTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input;
+  string waterTremolo;
+
+  // Neighbor data
+  waterTremolo = "#\n#ATOMDATA Id Type neighbors=2\n1 H 3 0\n2 H 3 0\n3 O 1 2\n";
+  input << waterTremolo;
+  testParser->load(&input);
+
+  CPPUNIT_ASSERT_EQUAL(3, World::getInstance().numAtoms());
+  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(8))->
+      IsBondedTo(World::getInstance().getAtom(AtomByType(1))));
+  input.clear();
+}
+
+void ParserUnitTest::readAndWriteTremoloImprDataInformationTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input, output;
+  string waterTremolo;
+
+  // Neighbor data
+  waterTremolo = "#\n#ATOMDATA Id Type imprData\n8 H 9-10\n9 H 10-8,8-10\n10 O -\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  testParser->save(&output);
+  CPPUNIT_ASSERT_EQUAL(3, World::getInstance().numAtoms());
+  CPPUNIT_ASSERT(output.str().find("2-0,0-2") != string::npos);
+  input.clear();
+  output.clear();
+}
+
+void ParserUnitTest::readAndWriteTremoloTorsionInformationTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream input, output;
+  string waterTremolo;
+
+  // Neighbor data
+  waterTremolo = "#\n#ATOMDATA Id Type torsion\n8 H 9-10\n9 H 10-8,8-10\n10 O -\n";
+  input << waterTremolo;
+  testParser->load(&input);
+  testParser->save(&output);
+  CPPUNIT_ASSERT_EQUAL(3, World::getInstance().numAtoms());
+  CPPUNIT_ASSERT(output.str().find("2-0,0-2") != string::npos);
+  input.clear();
+  output.clear();
+}
+
+void ParserUnitTest::writeTremoloTest() {
+  TremoloParser* testParser = new TremoloParser();
+  stringstream output;
+
+  // with the maximum number of fields and minimal information, default values are printed
+  atom* newAtom = World::getInstance().createAtom();
+  newAtom->type = World::getInstance().getPeriode()->FindElement(1);
+  testParser->setFieldsForSave("x=3 u=3 F stress Id neighbors=5 imprData GroupMeasureTypeNo Type extType name resName chainID resSeq occupancy tempFactor segID Charge charge GrpTypeNo torsion");
+  testParser->save(&output);
+  CPPUNIT_ASSERT(output.str() == "# ATOMDATA\tx=3\tu=3\tF\tstress\tId\tneighbors=5\timprData\tGroupMeasureTypeNo\tType\textType\tname\tresName\tchainID\tresSeq\toccupancy\ttempFactor\tsegID\tCharge\tcharge\tGrpTypeNo\ttorsion\n0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t-\t0\tH\t-\t-\t-\t0\t0\t0\t0\t0\t0\t0\t0\t-\t\n");
+
+  cout << "testing the tremolo parser is done" << endl;
+}
Index: src/unittests/ParserUnitTest.hpp
===================================================================
--- src/unittests/ParserUnitTest.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/unittests/ParserUnitTest.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,40 @@
+/*
+ * ParserUnitTest.hpp
+ *
+ *  Created on: Mar 3, 2010
+ *      Author: metzler
+ */
+#ifndef PARSERUNITTEST_HPP_
+#define PARSERUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+#include <string>
+
+class ParserUnitTest :  public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( ParserUnitTest ) ;
+  CPPUNIT_TEST ( rewriteAnXyzTest );
+  CPPUNIT_TEST ( readTremoloPreliminaryCommentsTest );
+  CPPUNIT_TEST ( readTremoloCoordinatesTest );
+  CPPUNIT_TEST ( readTremoloVelocityTest );
+  CPPUNIT_TEST ( readTremoloNeighborInformationTest );
+  CPPUNIT_TEST ( readAndWriteTremoloImprDataInformationTest );
+  CPPUNIT_TEST ( readAndWriteTremoloTorsionInformationTest );
+  CPPUNIT_TEST ( writeTremoloTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void rewriteAnXyzTest();
+  void readTremoloPreliminaryCommentsTest();
+  void readTremoloCoordinatesTest();
+  void readTremoloVelocityTest();
+  void readTremoloNeighborInformationTest();
+  void readAndWriteTremoloImprDataInformationTest();
+  void readAndWriteTremoloTorsionInformationTest();
+  void writeTremoloTest();
+};
+
+#endif /* PARSERUNITTEST_HPP_ */
Index: src/unittests/SingletonTest.cpp
===================================================================
--- src/unittests/SingletonTest.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/unittests/SingletonTest.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -52,5 +52,5 @@
     count1++;
   }
-  // explicit copy constructor to catch if thsi is ever called
+  // explicit copy constructor to catch if this is ever called
   SingletonStub2(const SingletonStub2&){
     CPPUNIT_FAIL    ( "Copy constructor of Singleton called" );
Index: src/unittests/TestRunnerMain.cpp
===================================================================
--- src/unittests/TestRunnerMain.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/unittests/TestRunnerMain.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -6,8 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#ifdef HAVE_ECUT
 // give the main function its correct name
 #define CPPUNIT_MAIN main
-
 // include the TestRunnerClient file containing the main class
 #include "../../../TestRunnerClient.h"
 #include "../../../TestRunnerClient.cpp"
+#else
+#include "UnitTestMain.cpp"
+#endif
+
